# Define your custom views here or overwrite the default views. Default
# CRUD operations are generated by the ringo frameworkd.
import logging
from pyramid.view import view_config
from formbar.form import Validator
from ringo.lib.helpers import get_action_routename
from ringo_eccourse.model import Eccourse
import ringo_eccourse.lib.plz as eccourse_plz
from ringo.views.base import create, update

 
log = logging.getLogger(name=__name__)
 
 
def course_nr_validator(field, data, context, *args, **kwargs):
    '''
    Validator for unique course numbers.

    This is already done at the database level, but we have to check this so
    that the error is properly presented on the form.
    '''
    item_id = context._item.id
    result = context._dbsession.query(Eccourse).filter(Eccourse.number == data.get(field)).all()
    if len(result) == 0:
        return True
    
    if len(result) == 1:
        return result[0].id == item_id

    return False

